<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

		<title>PHP5 - Objekt Orientierte Programmierung</title>

		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<link rel="stylesheet" href="../reveal.js-3.2.0/css/reveal.css">
		<link rel="stylesheet" href="../reveal.js-3.2.0/css/theme/sky.css" id="theme">
		<style type="text/css">
			.reveal section img.medium {
				width: 20%;
				border: none;
			}
		</style>
	</head>

	<body>

		<div class="reveal">

			<div class="slides">

				<section>
					<h1><img class="medium" src="images/PHP_Logo.png" alt="PHP" /></h1>
					<h2><img class="medium" src="../../images/pro_400.jpg" alt="dcodernz" />
					<h2>Teil 2 - Funktionen</h2>
					<h3>mit dcodernz</h3>
				</section>

				<section>
					<h3>Einf&uuml;hrungsvideo</h3>

					<iframe width="420" height="315" src="https://www.youtube.com/embed/m_lSFHKeQck" frameborder="0" allowfullscreen></iframe>
					<p>Ein kleiner Kickstart.</p>
				</section>

				<section>
					<h3>Lektion 2 - PHP's Reiche Funktionslibrary</h3>

					<ul>
						<li>Was sind Funktionen (functions)?</li>
						<li>Wie benutze ich sie?</li>
						<li>Wie schreibe ich sie?</li>
						<li>Nicht das Rad neu erfinden!</li>
						<li>Beispiele.</li>
					</ul>
				</section>

				<section>
					<h3>Was sind Funktionen (functions)?</h3>
					<ul>
						<li>Enkapsulierte Funktionalit&auml;t.</li>
						<li>Etwas, was man wiederverwerten kann.</li>
						<li>Eine Funktion (function) hat:
							<ul>
								<li>Einen namen (normalerweise!).</li>
								<li>0 - N Parameter mit oder ohne Typ</li>
								<li>Einen R&uuml;ckgabewert (return) - optional!</li>
							</ul>
						</li>
					</ul>
				</section>

				<section>
					<h3>Wie benutze ich sie?</h3>
					<pre>$variable = functionsName($parameter1);
functionsName($parameter1);
// oder
$variable = functionsName($parameter1, ..., $parameterN);</pre>
					<p>Es gibt noch andere M&ouml;glichkeiten, aber dies sind die wichtigsten.</p>
				</section>

				<section>
					<h3>Wie schreibe ich sie?</h3>
					<pre>function funktionsName($parameter1, ..., $parameterN) {
	// benutze $parameter1 bis N irgendwie
	return $r&uuml;ckgabeWert; // optional
}

function funktionsName(&amp;$parameter1, ..., $parameterN) {
	// benutze $parameter1 bis N irgendwie
	// $parameter1 kann ver&auml;ndert werden und wird ver&auml;ndert "zur&uuml;ckgegeben"!
	return $r&uuml;ckgabeWert; // optional
}
				</section>

				<section>
					<h3>Nicht das Rad neu erfinden!</h3>
				</section>

				<section>
					<h3>Beispiel - implode</h3>
					<pre>string implode ( string $glue , array $pieces )
string implode ( array $pieces )</pre>
					<a href="https://secure.php.net/manual/de/function.implode.php">
						https://secure.php.net/manual/de/function.implode.php
					</a>
				</section>

				<section>
					<h3>Beispiel - preg_match</h3>
					<pre>int preg_match (
	string $pattern ,
	string $subject 
		[, array &$matches 
			[, int $flags = 0 
				[, int $offset = 0 ]
			]
		]
)</pre>
					<a href="https://secure.php.net/manual/de/function.preg-match.php">
						https://secure.php.net/manual/de/function.preg-match.php
					</a>
				</section>

				<section>
					<h3>Funktionen - Video</h3>

					<iframe width="420" height="315" src="https://www.youtube.com/embed/bywJ9aXwVhA" frameborder="0" allowfullscreen></iframe>
				</section>

			</div>

		</div>

		<script src="../reveal.js-3.2.0/lib/js/head.min.js"></script>
		<script src="../reveal.js-3.2.0/js/reveal.js"></script>

		<script>

			Reveal.initialize({
				history: true,
				transition: 'convex',

				math: {
					// mathjax: 'http://cdn.mathjax.org/mathjax/latest/MathJax.js',
					config: 'TeX-AMS_HTML-full'
				},

				dependencies: [
					{ src: '../reveal.js-3.2.0/lib/js/classList.js' },
					{ src: '../reveal.js-3.2.0/plugin/math/math.js', async: true }
				]
			});

		</script>

	</body>
</html>
